/**
 * This is the outermost environment, containing predefined names. The
 * names +, -, *, /, %, =, !=, &lt;, &gt;, &lt;=, and &gt;= are
 * associated with corresponding functions.
 */
public class InitialEnvironment implements Environment {
    	
    private final static Function
	PLUS =
        new IntOperation(){
            public int compute(int i1, int i2){
                return i1 + i2;
            }
	};

    private final static Function
	MINUS =
        new IntOperation(){
            public int compute(int i1, int i2){
                return i1 - i2;
            }
	};

    private final static Function
	TIMES =
        new IntOperation(){
            public int compute(int i1, int i2){
                return i1 * i2;
            }
	};

    private final static Function
	DIV =
        new IntOperation(){
            public int compute(int i1, int i2){
                return i1 / i2;
            }
	};

    private final static Function
	MOD =
        new IntOperation(){
            public int compute(int i1, int i2){
                return i1 % i2;
            }
	};

    private final static Function
	EQ =
        new IntComparison(){
            public boolean compute(int i1, int i2){
                return i1 == i2;
            }
	};

    private final static Function
	NE =
        new IntComparison(){
            public boolean compute(int i1, int i2){
                return i1 != i2;
            }
	};

    private final static Function
	LT =
        new IntComparison(){
            public boolean compute(int i1, int i2){
                return i1 < i2;
            }
	};

    private final static Function
	LE =
        new IntComparison(){
            public boolean compute(int i1, int i2){
                return i1 <= i2;
            }
	};

    private final static Function
	GT =
        new IntComparison(){
            public boolean compute(int i1, int i2){
                return i1 > i2;
            }
	};

    private final static Function
	GE =
        new IntComparison(){
            public boolean compute(int i1, int i2){
                return i1 >= i2;
            }
	};

    public Object get(String name) {
        if(name.equals("+")){
            return PLUS;
        } else if(name.equals("-")){
            return MINUS;			
        } else if(name.equals("*")){
            return TIMES;			
        } else if(name.equals("/")){
            return DIV;			
        } else if(name.equals("%")){
            return MOD;			
        } else if(name.equals("=")){
            return EQ;			
        } else if(name.equals("!=")){
            return NE;			
        } else if(name.equals("<")){
            return LT;			
        } else if(name.equals(">")){
            return GT;			
        } else if(name.equals(">=")){
            return GE;			
        } else if(name.equals("<=")){
            return LE;			
        } else {
            throw new Error("Undefined name " + name);
        }
    }
}